package gssim.db.utils;

import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.Array;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Date;
import java.sql.NClob;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.RowId;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.SQLXML;
import java.sql.Statement;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Map;

/**
 * 
 * @author Jarek Szymczak
 *
 */
public class ResultSetAdapter implements ResultSet
{
	private ResultSet result;
	
	public ResultSetAdapter(ResultSet result)
	{
		this.result = result;
	}

	@Override
	public boolean getBoolean(int columnIndex) throws SQLException {
		return result.getBoolean(columnIndex);
	}

	@Override
	public boolean getBoolean(String columnLabel) throws SQLException {
		return result.getBoolean(columnLabel);
	}
	
	public Boolean getBooleanObj(int columnIndex) throws SQLException {
		Boolean res = result.getBoolean(columnIndex);
		
		if(result.wasNull())
			return null;
		else
			return res;
	}

	public Boolean getBooleanObj(String columnLabel) throws SQLException {
		Boolean res = result.getBoolean(columnLabel);
		
		if(result.wasNull())
			return null;
		else
			return res;
	}

	@Override
	public double getDouble(int columnIndex) throws SQLException {
		return result.getDouble(columnIndex);
	}

	@Override
	public double getDouble(String columnLabel) throws SQLException {
		return result.getDouble(columnLabel);
	}
	
	public Double getDoubleObj(int columnIndex) throws SQLException {
		Double res = result.getDouble(columnIndex);
		
		if(result.wasNull())
			return null;
		else
			return res;
	}

	public Double getDoubleObj(String columnLabel) throws SQLException {
		Double res = result.getDouble(columnLabel);
		
		if(result.wasNull())
			return null;
		else
			return res;
	}

	@Override
	public float getFloat(int columnIndex) throws SQLException {
		return result.getFloat(columnIndex);
	}

	@Override
	public float getFloat(String columnLabel) throws SQLException {
		return result.getFloat(columnLabel);
	}
	
	public Float getFloatObj(int columnIndex) throws SQLException {
		Float res = result.getFloat(columnIndex);
		
		if(result.wasNull())
			return null;
		else
			return res;
	}

	public Float getFloatObj(String columnLabel) throws SQLException {
		Float res = result.getFloat(columnLabel);
		
		if(result.wasNull())
			return null;
		else
			return res;
	}

	@Override
	public int getInt(int columnIndex) throws SQLException {
		return result.getInt(columnIndex);
	}

	@Override
	public int getInt(String columnLabel) throws SQLException {
		return result.getInt(columnLabel);
	}
	
	public Integer getIntObj(int columnIndex) throws SQLException {
		Integer res = result.getInt(columnIndex);
		
		if(result.wasNull())
			return null;
		else
			return res;
	}

	public Integer getIntObj(String columnLabel) throws SQLException {
		Integer res = result.getInt(columnLabel);
		
		if(result.wasNull())
			return null;
		else
			return res;
	}

	@Override
	public String getString(int columnIndex) throws SQLException {
		return result.getString(columnIndex);
	}

	@Override
	public String getString(String columnLabel) throws SQLException {
		return result.getString(columnLabel);
	}

	@Override
	public Timestamp getTimestamp(int columnIndex) throws SQLException {
		return result.getTimestamp(columnIndex);
	}

	@Override
	public Timestamp getTimestamp(String columnLabel) throws SQLException {
		return result.getTimestamp(columnLabel);
	}

	@Override
	public Timestamp getTimestamp(int columnIndex, Calendar cal)
			throws SQLException {
		return result.getTimestamp(columnIndex, cal);
	}

	@Override
	public Timestamp getTimestamp(String columnLabel, Calendar cal)
			throws SQLException {
		return result.getTimestamp(columnLabel, cal);
	}
	
	
	@Override
	public boolean isWrapperFor(Class<?> iface) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public <T> T unwrap(Class<T> iface) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean absolute(int row) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void afterLast() throws SQLException {
		throw new SQLException("Not implemented");
		
	}

	@Override
	public void beforeFirst() throws SQLException {
		throw new SQLException("Not implemented");
		
	}

	@Override
	public void cancelRowUpdates() throws SQLException {
		throw new SQLException("Not implemented");
		
	}

	@Override
	public void clearWarnings() throws SQLException {
		throw new SQLException("Not implemented");
		
	}

	@Override
	public void close() throws SQLException {
		throw new SQLException("Not implemented");
		
	}

	@Override
	public void deleteRow() throws SQLException {
		throw new SQLException("Not implemented");
		
	}

	@Override
	public int findColumn(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean first() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Array getArray(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Array getArray(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public InputStream getAsciiStream(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public InputStream getAsciiStream(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public BigDecimal getBigDecimal(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public BigDecimal getBigDecimal(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public BigDecimal getBigDecimal(int columnIndex, int scale)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public BigDecimal getBigDecimal(String columnLabel, int scale)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public InputStream getBinaryStream(int columnIndex) throws SQLException {
		return result.getBinaryStream(columnIndex); 
	}

	@Override
	public InputStream getBinaryStream(String columnLabel) throws SQLException {
		return result.getBinaryStream(columnLabel);
	}

	@Override
	public Blob getBlob(int columnIndex) throws SQLException {
		return result.getBlob(columnIndex);
	}

	@Override
	public Blob getBlob(String columnLabel) throws SQLException {
		return result.getBlob(columnLabel);
	}

	@Override
	public byte getByte(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public byte getByte(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public byte[] getBytes(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public byte[] getBytes(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Reader getCharacterStream(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Reader getCharacterStream(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Clob getClob(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Clob getClob(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public int getConcurrency() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public String getCursorName() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Date getDate(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Date getDate(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Date getDate(int columnIndex, Calendar cal) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Date getDate(String columnLabel, Calendar cal) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public int getFetchDirection() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public int getFetchSize() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public int getHoldability() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public long getLong(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public long getLong(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public ResultSetMetaData getMetaData() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Reader getNCharacterStream(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Reader getNCharacterStream(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public NClob getNClob(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public NClob getNClob(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public String getNString(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public String getNString(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Object getObject(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Object getObject(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Object getObject(int columnIndex, Map<String, Class<?>> map)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Object getObject(String columnLabel, Map<String, Class<?>> map)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Ref getRef(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Ref getRef(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public int getRow() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public RowId getRowId(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public RowId getRowId(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public SQLXML getSQLXML(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public SQLXML getSQLXML(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public short getShort(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public short getShort(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Statement getStatement() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Time getTime(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Time getTime(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Time getTime(int columnIndex, Calendar cal) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public Time getTime(String columnLabel, Calendar cal) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public int getType() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public URL getURL(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public URL getURL(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public InputStream getUnicodeStream(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public InputStream getUnicodeStream(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public SQLWarning getWarnings() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void insertRow() throws SQLException {
		throw new SQLException("Not implemented");
		
	}

	@Override
	public boolean isAfterLast() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean isBeforeFirst() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean isClosed() throws SQLException {
		return result.isClosed();
	}

	@Override
	public boolean isFirst() throws SQLException {
		return result.isFirst();
	}

	@Override
	public boolean isLast() throws SQLException {
		return result.isLast();
	}

	@Override
	public boolean last() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void moveToCurrentRow() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void moveToInsertRow() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean next() throws SQLException {
		return result.next();
	}

	@Override
	public boolean previous() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void refreshRow() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean relative(int rows) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean rowDeleted() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean rowInserted() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean rowUpdated() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void setFetchDirection(int direction) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void setFetchSize(int rows) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateArray(int columnIndex, Array x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateArray(String columnLabel, Array x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateAsciiStream(int columnIndex, InputStream x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateAsciiStream(String columnLabel, InputStream x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateAsciiStream(int columnIndex, InputStream x, int length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateAsciiStream(String columnLabel, InputStream x, int length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateAsciiStream(int columnIndex, InputStream x, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateAsciiStream(String columnLabel, InputStream x, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBigDecimal(int columnIndex, BigDecimal x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBigDecimal(String columnLabel, BigDecimal x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBinaryStream(int columnIndex, InputStream x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBinaryStream(String columnLabel, InputStream x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBinaryStream(int columnIndex, InputStream x, int length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBinaryStream(String columnLabel, InputStream x, int length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBinaryStream(int columnIndex, InputStream x, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBinaryStream(String columnLabel, InputStream x,
			long length) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBlob(int columnIndex, Blob x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBlob(String columnLabel, Blob x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBlob(int columnIndex, InputStream inputStream)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBlob(String columnLabel, InputStream inputStream)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBlob(int columnIndex, InputStream inputStream, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBlob(String columnLabel, InputStream inputStream,
			long length) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBoolean(int columnIndex, boolean x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBoolean(String columnLabel, boolean x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateByte(int columnIndex, byte x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateByte(String columnLabel, byte x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBytes(int columnIndex, byte[] x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateBytes(String columnLabel, byte[] x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateCharacterStream(int columnIndex, Reader x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateCharacterStream(String columnLabel, Reader reader)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateCharacterStream(int columnIndex, Reader x, int length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateCharacterStream(String columnLabel, Reader reader,
			int length) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateCharacterStream(int columnIndex, Reader x, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateCharacterStream(String columnLabel, Reader reader,
			long length) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateClob(int columnIndex, Clob x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateClob(String columnLabel, Clob x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateClob(int columnIndex, Reader reader) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateClob(String columnLabel, Reader reader)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateClob(int columnIndex, Reader reader, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateClob(String columnLabel, Reader reader, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateDate(int columnIndex, Date x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateDate(String columnLabel, Date x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateDouble(int columnIndex, double x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateDouble(String columnLabel, double x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateFloat(int columnIndex, float x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateFloat(String columnLabel, float x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateInt(int columnIndex, int x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateInt(String columnLabel, int x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateLong(int columnIndex, long x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateLong(String columnLabel, long x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNCharacterStream(int columnIndex, Reader x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNCharacterStream(String columnLabel, Reader reader)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNCharacterStream(int columnIndex, Reader x, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNCharacterStream(String columnLabel, Reader reader,
			long length) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNClob(int columnIndex, NClob nClob) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNClob(String columnLabel, NClob nClob)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNClob(int columnIndex, Reader reader) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNClob(String columnLabel, Reader reader)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNClob(int columnIndex, Reader reader, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNClob(String columnLabel, Reader reader, long length)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNString(int columnIndex, String nString)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNString(String columnLabel, String nString)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNull(int columnIndex) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateNull(String columnLabel) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateObject(int columnIndex, Object x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateObject(String columnLabel, Object x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateObject(int columnIndex, Object x, int scaleOrLength)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateObject(String columnLabel, Object x, int scaleOrLength)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateRef(int columnIndex, Ref x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateRef(String columnLabel, Ref x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateRow() throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateRowId(int columnIndex, RowId x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateRowId(String columnLabel, RowId x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateSQLXML(int columnIndex, SQLXML xmlObject)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateSQLXML(String columnLabel, SQLXML xmlObject)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateShort(int columnIndex, short x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateShort(String columnLabel, short x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateString(int columnIndex, String x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateString(String columnLabel, String x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateTime(int columnIndex, Time x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateTime(String columnLabel, Time x) throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateTimestamp(int columnIndex, Timestamp x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public void updateTimestamp(String columnLabel, Timestamp x)
			throws SQLException {
		throw new SQLException("Not implemented");
	}

	@Override
	public boolean wasNull() throws SQLException {
		return result.wasNull();
	}
}
