package gssim.gssimstudio.editor.gssim
{
	import flash.events.Event;
	
	import flexlib.mdi.containers.MDICanvas;
	import flexlib.mdi.containers.MDIWindow;
	import flexlib.mdi.events.MDIManagerEvent;
	
	import mx.controls.Alert;
	import mx.controls.TextArea;
	import mx.events.CloseEvent;
	
	/**
	 * Helps handle windows on MDICanvas
	 */
	public class WindowManager
	{
		private var mdiCanvas : MDICanvas;
		private var eventMonitor:TextArea;
		private var queuedEvent:MDIManagerEvent;
		private var _confirmClose :Boolean = false;
		public function get confirmClose() : Boolean
		{
			return _confirmClose;
		}
		public function set confirmClose(value: Boolean):void
		{
			_confirmClose = value;
		}
		
		
		public function WindowManager(canvas : MDICanvas)
		{
			// create textfield
			eventMonitor = new TextArea();
			eventMonitor.percentWidth = 100;
			eventMonitor.height = 150;
			
			mdiCanvas = canvas;
					
			//listen for all window events
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_ADD, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_MINIMIZE, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_RESTORE, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_MAXIMIZE, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_CLOSE, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_FOCUS_START, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_FOCUS_END, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_DRAG_START, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_DRAG, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_DRAG_END, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_RESIZE_START, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_RESIZE, windowEventHandler);
			mdiCanvas.windowManager.addEventListener(MDIManagerEvent.WINDOW_RESIZE_END, windowEventHandler);
		}
		
		// default event handler
		private function windowEventHandler(event:Event):void
		{
			if(event is MDIManagerEvent)
			{
				var mgrEvent:MDIManagerEvent = event as MDIManagerEvent;
				if(eventMonitor.parent != null)
				{
					eventMonitor.text += mgrEvent.window.title + ": " + event.type + "\n";
					eventMonitor.verticalScrollPosition = eventMonitor.maxVerticalScrollPosition;
					eventMonitor.validateNow();
				}
			}
		}
	}
}
