package gssim.gssimstudio.editor.gssim.errors.workload
{
	import gssim.gssimstudio.editor.gssim.editors.workload.ParameterAttributesWindow;
	import gssim.gssimstudio.editor.gssim.editors.workload.RandParamsWindow;
	import gssim.gssimstudio.editor.gssim.errors.AbstractError;
	import gssim.gssimstudio.editor.gssim.workload.ParameterAttributes;
	import gssim.gssimstudio.editor.gssim.workload.RandParams;
	
	import gssim.gssimstudio.editor.script.views.ViewsHelper;

	/**
	 * Error raised if the probabilistic parameters are invalid
	 */
	public class ParametersError extends AbstractError
	{
		private var params : ParameterAttributes;
		
		public function ParametersError(messageCode : String, params : ParameterAttributes)
		{
			super(messageCode);
			this.message = params.parentTagName + ":";
			this.params = params;
		}
		
		public override function solve() : void
		{
			var window : ParameterAttributesWindow = new ParameterAttributesWindow();
			ViewsHelper.WorkloadCanvas.windowManager.add(window);
			window.setParams(params);
		}
	}
}
