package gssim.gssimstudio.editor.gssim.experiment
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.net.FileReference;
	import flash.utils.ByteArray;
	
	/**
	 * Class for storing files.
	 */
	public class FileProxy extends EventDispatcher implements Proxy
	{	
		public static const CANCELLED : String = "(cancelled)";
		
		/**
		 * File reference to picked file
		 */
		private var fref : FileReference;
		
		[Bindable]
		public var filename : String;
		[Bindable]
		public var valid : Boolean;
		
		public var data : ByteArray;
		
		public function FileProxy(name : String = "")
		{
			this.filename = name;
			//FIXME: maybe a better way to do this ?
			if (name != "") valid = true;
			else valid = false;
		}

		public override function toString() : String
		{
			return filename;
		}
		
		/**
		 * Load file using file reference browse() method
		 */
		public function LoadFile() : void
		{
			fref = new FileReference();
			fref.addEventListener(Event.SELECT, selectHandler);
			fref.addEventListener(Event.COMPLETE, completeHandler);
			fref.addEventListener(Event.CANCEL, cancelHandler);
			fref.browse();
		}
		
		/**
		 * File upload was cancelled
		 */
		private function cancelHandler(event:Event):void
		{
			filename = CANCELLED;
			valid = false;
			fref = null;
			dispatchEvent(new Event(Event.COMPLETE));
		}
		
		/**
		 * User selected file from file browser - load it
		 */
		private function selectHandler(event:Event):void
		{
		    fref.load();
		}
		
		/**
		 * File upload was finished
		 */
		private function completeHandler(event:Event):void
		{
			filename = fref.name;
			data = fref.data;
			//clean reference to file (because data is already stored)
			fref = null;
			valid = true;
			dispatchEvent(new Event(Event.COMPLETE));
		}

	}
}
