package gssim.gssimstudio.editor.gssim.resources
{
	import gssim.gssimstudio.editor.gssim.errors.AbstractError;
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.errors.workload.PreferenceError;
	import gssim.gssimstudio.editor.gssim.resources.types.HostParameterType;
	import gssim.gssimstudio.editor.gssim.resources.types.OtherParameterType;
	import gssim.gssimstudio.editor.gssim.workload.types.PreferenceType;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;

	/**
	 * Class for storing resource other parameter
	 */
	public class OtherParameter extends XMLBasicWrapper implements ValidableObject
	{
		/**
		 * Type of the other parameter
		 */
		[Bindable]
		public var otherParameterType : String;
		
		/**
		 * Value of parameter
		 */
		[Bindable]
		public var otherParameterValue : String;
		
		public function OtherParameter()
		{
			otherParameterType = OtherParameterType.energyprofile;
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = <otherParameter />;
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			addStringAttribute(xml, "name", otherParameterType, true);
			appendChildWithText(xml, "<paramValue/>", otherParameterValue, true, addLabel); 
			return xml;
		}
		
		public function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			/*
			var ae : AbstractError;
			for each (var param : PreferenceParameter in preferenceParameters)
			{
				if (preferenceType == null) ac.addItem(new PreferenceError("MissingPreferenceTypeError", this));
				for each (ae in param.validate()) ac.addItem(ae);
			}*/
			return ac;
		}
	}
}
