package gssim.gssimstudio.editor.gssim.topology
{
	import com.degrafa.core.utils.ColorKeys;
	
	import flash.events.Event;
	
	import mx.collections.ArrayCollection;
	
	import gssim.gssimstudio.editor.script.event.ObjectEvent;

	public class GenderObject extends GraphItem
	{
		/***********************
		 * Static embed images *
		 ***********************/
		[Embed(source="/gssim/gssimstudio/editor/assets/resource.png")] 
		[Bindable] 
		public static var ResourceImageCls:Class;
		[Embed(source="/gssim/gssimstudio/editor/assets/router.png")] 
		[Bindable] 
		public static var RouterImageCls:Class;
		[Embed(source="/gssim/gssimstudio/editor/assets/user.png")] 
		[Bindable] 
		public static var UserImageCls:Class;
		[Embed(source="/gssim/gssimstudio/editor/assets/cluster.png")] 
		[Bindable] 
		public static var ClusterImageCls:Class;
		
		public var links : ArrayCollection;
		
		/**
		 *  Dispatched when an object moves on canvas.
		 *
		 *  @eventType script.event.ObjectMouseEvent
		 */
		[Event(name="ObjectMoved", type="script.event.ObjectEvent")]
		
		public static const OBJECT_MOVED:String = "ObjectMoved";
		
		private var _selected : Boolean;
		public function set selected(value : Boolean) :void { _selected = value; dispatchEvent(new Event("selected")); };
		public function get selected() : Boolean { return _selected; };
		
		[Bindable(event="selected")]
		public function get selectedColor() : uint
		{
			if (_selected)
				return ColorKeys.GREEN;
			return ColorKeys.BLACK;
		}
		
		public function GenderObject(name : String, source : Class)
		{
			super(name);
			this.source = source;
			links = new ArrayCollection();
		}
		
		public override function dispatchMoveAction() : void
		{
			for each (var link : NetworkObjectLinker in links)
			{
				link.refresh();
			}
			dispatchEvent(new ObjectEvent(OBJECT_MOVED, this));
		}
		
		/**
		 * Update all link names that connects to this object
		 */
		public function UpdateLinkNames() : void
		{
			for each (var k : NetworkObjectLinker in links)
			{
				k.UpdateID();
			}
		}
		
		/**
		 * Clear all links
		 */
		public function clean() : void
		{
			for each (var k : NetworkObjectLinker in links)
			{
				if (k.NodeFrom != this) k.NodeFrom.removeLink(k);
				else k.NodeTo.removeLink(k);
				k.graphics.clear();
			}
		}
		
		/**
		 * Remove certain link
		 */
		public function removeLink(link : NetworkObjectLinker) : void
		{
			links.removeItemAt(links.getItemIndex(link));
		}
		
		/**
		 * Returns true if this object can be linked with the object from argument
		 */
		public function canBeConnected(object : GenderObject) : Boolean
		{
			return true;
		}
	}
}
