package gssim.gssimstudio.editor.gssim.topology
{
	import gssim.gssimstudio.editor.gssim.resources.ComputingResource;
	import gssim.gssimstudio.editor.gssim.resources.QueueResource;
	
	import mx.collections.ArrayCollection;

	/**
	 * Object representing Resource
	 */
	public class ResourceObject extends GenderObject
	{
		/**
		 * Array of Resource
		 */
		public var clusteredResources : ArrayCollection;
		
		/**
		 * Defines if this resource is a cluster of resources
		 */
		public var cluster : Boolean;
		
		public var queue : QueueResource;
		public var frontend : ComputingResource;
		
		public function ResourceObject(name : String, cluster : Boolean = false)
		{
			super(name, (cluster ? ClusterImageCls : ResourceImageCls));
			this.cluster = cluster;
			clusteredResources = new ArrayCollection();
		}
		
		public override function canBeConnected(object : GenderObject) : Boolean
		{
			if (links.length > 0) return false;
			if (object is ResourceObject) return false;
			if (object is UserObject) return false;
			return true;
		}
		
		public function convertToCluster() : void
		{
			this.source = ClusterImageCls;
			this.cluster = true;
		}
	}
}
