package gssim.gssimstudio.editor.gssim.topology.layouts
{
	import gssim.gssimstudio.editor.gssim.topology.Graph;
	import gssim.gssimstudio.editor.gssim.topology.GraphItem;
	import gssim.gssimstudio.editor.gssim.topology.UserObject;
	
	/**
	 * Simple layout based on DFS algorithm
	 */
	public class gssimSimpleLayout implements ILayout
	{
		private var levels : Object; // map int -> int
		
		public function isStatic() : Boolean
		{
			return false;
		}
		
		public function gssimSimpleLayout()
		{
			levels = new Object();
		}

		public function doLayout(graph:Graph):void
		{
			//graph is empty
			if (!graph.hasNodes) return;
			
			//find user object, else take first item
			//reset nodes
			var id : String = graph.distinguishedGraphItem.id;
			for each (var node : GraphItem in graph.nodes)
			{
				if (node is UserObject) id = node.id;
				node.visited = false;
			}
			
			layout(0, graph, graph.find(id));
		}
		
		/**
		 * Recursive function for setting positions of nodes
		 */
		private function layout(level : Number, graph : Graph, item : GraphItem) : void
		{
			if (!levels.hasOwnProperty(level)) levels[level] = 0;
			else levels[level]++;
			item.visited = true;
			item.y = 96 * level;
			item.x = 192 * levels[level];
			item.dispatchMoveAction();
			for (var id : String in graph.neighbors(item.id))
			{
				var node : GraphItem = graph.find(id); 
				if (!node.visited) layout(level + 1, graph, node);
			}
		}
		
	}
}
