package gssim.gssimstudio.editor.gssim.workload
{
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	
	import mx.collections.ArrayCollection;
	
	/**
	 * Class for storing distribution parts
	 */
	public final class Dist extends ParameterAttributes implements ValidableObject
	{
		public static const probability : String = "probability";
		
		public function get Probability() : Number
		{
			return properties[probability] as Number;
		}
		
		public function set Probability(_value : Number) : void
		{
			properties[probability] = _value;
		}
		
		public function Dist(parentTagName : String)
		{
			super(parentTagName);
			tagName = <dist />;
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = super.getXML(addLabel);
			xml.appendChild(Probability);
			return xml;
		}
		
		/**
		 * Clone this Dist object to new instance
		 */
		public function clone() : Dist
		{
			var dist : Dist = new Dist(parentTagName);
			dist.Avg = Avg;
			dist.Distribution = Distribution;
			dist.Expr = Expr;
			dist.Id = Id;
			dist.Max = Max;
			dist.Min = Min;
			dist.Probability = Probability;
			dist.RefElementId = RefElementId;
			dist.Seed = Seed;
			dist.Stdev = Stdev;
			return dist;
		}
		
		public override function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			
			return ac;
		}
	}
}
