package gssim.gssimstudio.editor.gssim.workload
{
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;

	/**
	 * Stores periodic valid values type, which has probabilistic parameters connected with
	 * some time period during which they are valid
	 */
	public class PeriodicValidValues extends XMLBasicWrapper implements ValidableObject
	{
		private var properties : Object; // map id->value
		
		public var params : ParameterAttributes;
		
		public static const beginValidTime : String = "<BeginValidTime />";
		public static const endValidTime : String = "<EndValidTime />";
		
		public function get BeginValidTime() : Date
		{
			return properties[beginValidTime];
		}
		public function set BeginValidTime(_value : Date) : void
		{
			properties[beginValidTime] = _value;
		}
		
		public function get EndValidTime() : Date
		{
			return properties[endValidTime];
		}
		public function set EndValidTime(_value : Date) : void
		{
			properties[endValidTime] = _value;
		}
		
		public function PeriodicValidValues()
		{
			properties = new Object();
			properties[beginValidTime] = new Date();
			properties[endValidTime] = new Date();
			params = new ParameterAttributes("");
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = <PeriodicValidValues />;
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			params.addParamsToTag(xml);
			appendChildWithDate(xml, properties, beginValidTime, false, addLabel);
			appendChildWithDate(xml, properties, endValidTime, false, addLabel);
			return xml;
		}
		
		public function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			
			return ac;
		}
	}
}
