function ReplaceText($fileInfo)
{
    if( $_.GetType().Name -ne 'FileInfo')
    {
        # i.e. reject DirectoryInfo and other types
         return
    }

	if( $fileInfo.Extension -eq '.as' -or $fileInfo.Extension -eq '.mxml')
    {
        $old = $p1
		$mew = $p2
		(Get-Content $fileInfo.FullName) | % {$_ -replace $old, $mew} | Set-Content -path $fileInfo.FullName
		"Processed: " + $old + " in " + $fileInfo.FullName
    }
}

$loc = '.'
cd $loc
$files = Get-ChildItem . -recurse

$p1 = "package gssim"
$p2 = "package gssim.gssimstudio.editor.gssim"
$files | % { ReplaceText( $_ ) }

$p1 = "package flare"
$p2 = "package gssim.gssimstudio.editor.flare"
$files | % { ReplaceText( $_ ) }

$p1 = "package script"
$p2 = "package gssim.gssimstudio.editor.script"
$files | % { ReplaceText( $_ ) }

$p1 = "package views"
$p2 = "package gssim.gssimstudio.editor.views"
$files | % { ReplaceText( $_ ) }

$p1 = "package charts"
$p2 = "package gssim.gssimstudio.editor.charts"
$files | % { ReplaceText( $_ ) }

$p1 = "import gssim"
$p2 = "import gssim.gssimstudio.editor.gssim"
$files | % { ReplaceText( $_ ) }

$p1 = "import flare"
$p2 = "import gssim.gssimstudio.editor.flare"
$files | % { ReplaceText( $_ ) }

$p1 = "import script"
$p2 = "import gssim.gssimstudio.editor.script"
$files | % { ReplaceText( $_ ) }

$p1 = "import views"
$p2 = "import gssim.gssimstudio.editor.views"
$files | % { ReplaceText( $_ ) }

$p1 = "import charts"
$p2 = "import gssim.gssimstudio.editor.charts"
$files | % { ReplaceText( $_ ) }

$p1 = '"gssim.components.IconToggleButton"'
$p2 = '"gssim.gssimstudio.editor.gssim.components.IconToggleButton"'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:components="gssim.components'
$p2 = 'xmlns:components="gssim.gssimstudio.editor.gssim.components'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns="gssim.flexmdi'
$p2 = 'xmlns="gssim.gssimstudio.editor.gssim.flexmdi'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:v="gssim.editors.topology'
$p2 = 'xmlns:v="gssim.gssimstudio.editor.gssim.editors.topology'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns="gssim.editors.topology'
$p2 = 'xmlns="gssim.gssimstudio.editor.gssim.editors.topology'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:c="charts'
$p2 = 'xmlns:c="gssim.gssimstudio.editor.charts'
$files | % { ReplaceText( $_ ) }

$p1 = 'source="assets'
$p2 = 'source="/gssim/gssimstudio/editor/assets'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:cp="charts.com.connectedpixel.charts'
$p2 = 'xmlns:cp="gssim.gssimstudio.editor.charts.com.connectedpixel.charts'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:ssl="charts.smoothScrollingList'
$p2 = 'xmlns:ssl="gssim.gssimstudio.editor.charts.smoothScrollingList'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:v="charts.scheduling'
$p2 = 'xmlns:v="gssim.gssimstudio.editor.charts.scheduling'
$files | % { ReplaceText( $_ ) }

$p1 = 'styleValue: charts.com.connectedpixel.charts.skins'
$p2 = 'styleValue: gssim.gssimstudio.editor.charts.com.connectedpixel.charts.skins'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:gssim="gssim.editors.topology'
$p2 = 'xmlns:gssim="gssim.gssimstudio.editor.gssim.editors.topology'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:workload="gssim.editors.workload'
$p2 = 'xmlns:workload="gssim.gssimstudio.editor.gssim.editors.workload'
$files | % { ReplaceText( $_ ) }

$p1 = 'xmlns:minimap="gssim.minimap'
$p2 = 'xmlns:minimap="gssim.gssimstudio.editor.gssim.minimap'
$files | % { ReplaceText( $_ ) }

$p1 = 'gssim.topology.NetworkObjectLinker.CHANGE'
$p2 = 'gssim.gssimstudio.editor.gssim.topology.NetworkObjectLinker.CHANGE'
$files | % { ReplaceText( $_ ) }

$p1 = 'skinClass="gssim.skins.IconButtonSkin"'
$p2 = 'skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin"'
$files | % { ReplaceText( $_ ) }

$p1 = 'skinClass="gssim.skins.IconToggleButtonSkin"'
$p2 = 'skinClass="gssim.gssimstudio.editor.gssim.skins.IconToggleButtonSkin"'
$files | % { ReplaceText( $_ ) }

$p1 = '"gssim.components.IconButton"'
$p2 = '"gssim.gssimstudio.editor.gssim.components.IconButton"'
$files | % { ReplaceText( $_ ) }

$p1 = 'itemRenderer="gssim.editors.workload.DataGridCHRPButtonsRenderer"'
$p2 = 'itemRenderer="gssim.gssimstudio.editor.gssim.editors.workload.DataGridCHRPButtonsRenderer"'
$files | % { ReplaceText( $_ ) }

$p1 = 'itemRenderer="gssim.editors.workload.DataGridPrefsButtonsRenderer"'
$p2 = 'itemRenderer="gssim.gssimstudio.editor.gssim.editors.workload.DataGridPrefsButtonsRenderer"'
$files | % { ReplaceText( $_ ) }

$p1 = 'entryLayout="charts.scheduling.scheduleClasses.layout.SimpleLayout"'
$p2 = 'entryLayout="gssim.gssimstudio.editor.charts.scheduling.scheduleClasses.layout.SimpleLayout"'
$files | % { ReplaceText( $_ ) }

$p1 = 'entryRenderer="charts.scheduling.scheduleClasses.renderers.ColoredSolidScheduleEntryRenderer"'
$p2 = 'entryRenderer="gssim.gssimstudio.editor.charts.scheduling.scheduleClasses.renderers.ColoredSolidScheduleEntryRenderer"'
$files | % { ReplaceText( $_ ) }

$p1 = 'type="charts.scheduling.scheduleClasses.LayoutScrollEvent"'
$p2 = 'type="gssim.gssimstudio.editor.charts.scheduling.scheduleClasses.LayoutScrollEvent"'
$files | % { ReplaceText( $_ ) }

$p1 = 'source="../icon/'
$p2 = 'source="gssim/gssimstudio/editor/assets/icon/'
$files | % { ReplaceText( $_ ) }
