package gssim.gssimstudio.editor.script.command
{
	import flash.events.Event;
	
	import flexlib.mdi.containers.MDICanvas;
	
	import gssim.gssimstudio.editor.gssim.editors.topology.MinimapWindow;
	import gssim.gssimstudio.editor.gssim.editors.topology.ObjectCanvas;
	import gssim.gssimstudio.editor.gssim.topology.GenderObject;
	
	/**
	 * Open minimap window in network editor.
	 */
	public class OpenMinimapWindowCommand implements ICommand
	{		
		private static var minimap : MinimapWindow = new MinimapWindow();
		public var myContainer : MDICanvas;
		
		public function OpenMinimapWindowCommand(canvas : MDICanvas)
		{
			myContainer = canvas;
		}

		public function execute():void
		{
			if (myContainer == null) return;
			if (!myContainer.hasOwnProperty(minimap.id))
			{
				var prevX : Number = minimap.x;
				var prevY : Number = minimap.y;
				myContainer.windowManager.add(minimap);
				minimap.x = prevX;
				minimap.y = prevY;
			}
		}
		
		public function executeFromListener(event : Event):void
		{
			execute();
		}
		
		/* this should be in another command class */
		/**
		 * Update GenderObject position on the minimap
		 */
		public function update(object : GenderObject, wasDeleted : Boolean = false) : void
		{
			minimap.UpdateObject(object, wasDeleted);
		}
		
		/**
		 * Remove all items from minimap
		 */
		public function clean() : void
		{
			minimap.clean();
		}
		
		/**
		 * Recalculate minimap selection box bounds
		 */
		public function scale() : void
		{
			minimap.scale();
		}
		
		/**
		 * Initialize minimap window position
		 */
		public function init(target : ObjectCanvas) : void
		{
			minimap.init(target);
			minimap.x = minimap.originalX;
			minimap.y = minimap.originalY;
		}
	}
}
