package gssim.gssimstudio.editor.script.command
{
	import flash.events.Event;
	
	import flexlib.mdi.containers.MDICanvas;
	
	import gssim.gssimstudio.editor.gssim.topology.GenderObject;
	import gssim.gssimstudio.editor.gssim.topology.ResourceObject;
	import gssim.gssimstudio.editor.gssim.topology.RouterObject;
	import gssim.gssimstudio.editor.gssim.topology.UserObject;
	import gssim.gssimstudio.editor.gssim.editors.topology.ObjectParamsWindow;
	import gssim.gssimstudio.editor.gssim.editors.topology.paramsWindows.*;
	import mx.logging.errors.InvalidCategoryError;
	
	/**
	 * Open chart menu window for network editor.
	 */
	public class OpenObjectChartListWindowCommand implements ICommand
	{
		public var paramsWindow : ObjectParamsWindow;
		public var myContainer : MDICanvas;
		
		public function OpenObjectChartListWindowCommand(canvas : MDICanvas, object : GenderObject)
		{
			if (object is RouterObject)
			{
				paramsWindow = new RouterParamsWindow();
			}
			else if (object is ResourceObject)
			{
				paramsWindow = new ResourceParamsWindow();	
			}
			else if (object is UserObject)
			{
				paramsWindow = new UserParamsWindow();
			}
			else
			{
				throw new InvalidCategoryError("Wrong GenderObject type");
			}
			
			paramsWindow.init(object);
			myContainer = canvas;
		}

		public function execute():void
		{
			if (myContainer.getChildByName(paramsWindow.name) == null)
			{
				myContainer.windowManager.add(paramsWindow);
			}
		}
		
		public function executeFromListener(event : Event):void
		{
			execute();
		}
		
	}
}
